                .MODEL SMALL
                .386
                .CODE
                ORG     100H

start:          jmp     inizio

                include         sin.inc
                include         font.inc
                include         div32.inc
                include         msg.inc
                include         sin2.inc
                include         lung.inc

cont_char_iniz          DB      0
off_char_iniz           DB      0
cont_char               DB      0
off_char                DB      0
x                       DW      0
y                       DW      0
font_tbl                DW      31 DUP(0)
a                       DW      0
buffer                  DW      0
buffer2                 DW      0
pa                      DB      0
pb                      DB      64
pc                      DB      128
pd                      DB      192



inizio:         call    pal_off

                mov     ax,0013h
                int     10h

                call    pal_0

                mov     dx,03C4h
                mov     ax,0604h
                out     dx,ax
                mov     ax,0100h
                out     dx,ax
                mov     ax,0300h
                out     dx,ax
                mov     dx,03D4h
                mov     al,11h
                out     dx,al
                inc     dx
                in      al,dx
                and     al,7Fh
                out     dx,al
                dec     dx
                mov     ax,0014h
                out     dx,ax
                mov     ax,0E317h
                out     dx,ax

                call    alloc_font

                ;mov     dx,03C4h
                ;mov     ax,0F02h
                ;out     dx,ax
                mov     ax,0A000h
                mov     es,ax
                ;xor     di,di
                ;xor     eax,eax
                ;mov     cx,4000h
                ;rep     stosd

                ;call    set_pal
                call    make_pal
                call    draw_plasma
                call    draw_sine
                call    pal_on
                sub     a,2
                mov     ax,0A3E8h
                mov     es,ax
                inc     off_char_iniz
                call    draw_plasma
                call    draw_sine


ciclo_princ:    
                mov     dx,03DAh
lab1:           in      al,dx
                test    al,01
                jnz     lab1

                mov     cx,es
                sub     cx,0A000h
                mov     bx,cx
                shl     cx,4
                mov     dx,03D4h
                mov     al,0Ch
                mov     ah,ch
                out     dx,ax
                mov     al,0Dh
                mov     ah,cl
                out     dx,ax

                mov     dx,03DAh
lab2:           in      al,dx
                test    al,08
                jz      lab2

                mov     ax,0A3E8h
                sub     ax,bx
                mov     es,ax

                sub     a,4
                inc     off_char_iniz
                mov     bl,cont_char_iniz
                xor     bh,bh
                mov     cl,msg[bx]
                mov     bl,cl
                shl     bx,1
                mov     si,font_tbl[bx]
                mov     al,[si]
                cmp     off_char_iniz,al
                jl      spost_done
                mov     off_char_iniz,0
                inc     cont_char_iniz

spost_done:     cli
                call    draw_plasma
                call    draw_sine
                sti

                push    es
                xor     ax,ax
                mov     es,ax
                mov     ax,es:[041Ah]
                cmp     ax,es:[041Ch]
                pop     es
                jz      ciclo_princ
                
                xor     ax,ax
                int     16h

                call    pal_off

                mov     ax,0003h
                int     10h

                int     20h



alloc_font      PROC    NEAR

                mov     dl,30
                mov     si,OFFSET let_a
                mov     di,OFFSET fine_codice
                mov     bx,0
next_char:      mov     cl,lung_font[bx]
                push    bx
                shl     bx,1
                mov     font_tbl[bx],di
                pop     bx
                mov     [di],cl
                inc     di
next_line:      mov     ch,32
                mov     eax,[si]
next_pix:       shl     eax,1
                jnc     black
                mov     BYTE PTR [di],ch
                jmp     col_done
black:          mov     BYTE PTR [di],0
col_done:       inc     di
                dec     ch
                jnz     next_pix
                add     si,4
                dec     cl
                jnz     next_line
                inc     bx
                dec     dl
                jnz     next_char

                shl     bx,1
                mov     font_tbl[bx],di
                mov     BYTE PTR [di],16
                inc     di
                mov     cx,16*32
                mov     al,0
                rep     stosb

                mov     buffer,di

                ret

alloc_font      ENDP






draw_sine       PROC    NEAR

                mov     x,0
                mov     al,cont_char_iniz
                mov     cont_char,al
                mov     al,off_char_iniz
                mov     off_char,al

ciclo_sine:     mov     bx,x
                mov     di,bx
                shr     di,2
                mov     cl,bl
                and     cl,03h
                mov     ah,cl
                mov     al,04h
                mov     dx,03CEh
                out     dx,ax
                mov     ax,0102h
                mov     dx,03C4h
                shl     ah,cl
                out     dx,ax
                add     bx,a
                and     bx,01FFh
                mov     al,seno[bx]
                mov     cl,al
                add     bx,90
                and     bx,01FFh
                sub     al,seno[bx]
                mov     dl,al                           ;|DL|=numero pixel
                or      al,al
                jns     ok
                neg     al
ok:             mov     bl,al
                xor     bh,bh
                shl     bx,1
                mov     ax,div32[bx]                    ;AX=incremento

                xor     ch,ch
                add     cx,70                           ;linea partenza
                shl     cx,4
                add     di,cx
                shl     cx,2
                add     di,cx                           ;DI=ind. video

                mov     bl,cont_char
                xor     bh,bh
                mov     cl,msg[bx]
                mov     bl,cl
                shl     bx,1
                mov     si,font_tbl[bx]
                inc     si
                mov     cl,off_char
                xor     ch,ch
                shl     cx,5
                add     si,cx                           ;SI=ind. mem

                xor     ch,ch
                xor     dh,dh
                mov     bx,80
                or      dl,dl
                js      minore_0
                jz      next_row

maggiore_0:     mov     cl,[si]
                or      cl,cl
                jz      skip1
                not     BYTE PTR es:[di]
skip1:          sub     di,bx
                mov     cl,ah
                add     dh,al
                adc     si,cx
                dec     dl
                jnz     maggiore_0
                jmp     next_row

minore_0:       mov     cl,[si]
                or      cl,cl
                jz      skip2
                not     BYTE PTR es:[di]
skip2:          add     di,bx
                mov     cl,ah
                add     dh,al
                adc     si,cx
                inc     dl
                jnz     minore_0

next_row:       inc     off_char
                mov     bl,cont_char
                xor     bh,bh
                mov     cl,msg[bx]
                mov     bl,cl
                shl     bx,1
                mov     si,font_tbl[bx]
                mov     al,[si]
                cmp     off_char,al
                jl      no_next
                mov     off_char,0
                inc     cont_char

no_next:        inc     x
                cmp     x,320
                jl      ciclo_sine

                ret

draw_sine       ENDP

                




draw_plasma     PROC    NEAR

                mov     x,160
                mov     cx,0302h
                xor     di,di
                xor     bh,bh
ciclo_x:        mov     dx,03C4h
                mov     ax,cx
                out     dx,ax

                mov     dl,BYTE PTR x
                mov     bl,pb
                add     dl,seno2[bx]
                mov     bl,BYTE PTR x
                add     bl,pc
                add     dl,seno2[bx]
                add     dl,pd

                mov     dh,100

ciclo_y:        mov     al,dl
                mov     bl,dh
                add     bl,pa
                add     al,seno2[bx]
                add     al,dh

                mov     es:[di],al
                add     di,80
                mov     es:[di],al
                add     di,80

                dec     dh
                jnz     ciclo_y

                shl     ch,2
                and     ch,0Fh
                jz      no_ok
                sub     di,16000
                jmp     done
no_ok:          mov     ch,03h
                sub     di,16000-1

done:           dec     x
                jnz     ciclo_x

                inc     pa
                dec     pb
                dec     pb
                dec     pc
                inc     pd

                ret

draw_plasma     ENDP




make_pal        PROC    NEAR

                mov     bx,buffer
                mov     cx,64
                xor     al,al
ciclo_pal_1:    mov     BYTE PTR [bx],al
                mov     BYTE PTR [bx+1],0
                mov     BYTE PTR [bx+2],al
                ;mov     BYTE PTR [bx+3],0
                add     bx,3
                inc     al
                loop    ciclo_pal_1

                mov     cx,64
                mov     al,3Fh
ciclo_pal_2:    mov     BYTE PTR [bx],al
                mov     BYTE PTR [bx+1],0
                mov     BYTE PTR [bx+2],3Fh
                ;mov     BYTE PTR [bx+3],0
                add     bx,3
                dec     al
                loop    ciclo_pal_2

                mov     cx,64
                xor     al,al
                mov     ah,3Fh
ciclo_pal_3:    mov     BYTE PTR [bx],al
                mov     BYTE PTR [bx+1],al
                mov     BYTE PTR [bx+2],ah
                ;mov     BYTE PTR [bx+3],0
                add     bx,3
                inc     al
                dec     ah
                loop    ciclo_pal_3

                mov     cx,64
                mov     al,3Fh
ciclo_pal_4:    mov     BYTE PTR [bx],al
                mov     BYTE PTR [bx+1],al
                mov     BYTE PTR [bx+2],0
                ;mov     BYTE PTR [bx+3],0
                add     bx,3
                dec     al
                loop    ciclo_pal_4

                mov     buffer2,bx

                ret

make_pal        ENDP



pal_0           PROC    NEAR

                xor     cl,cl
pal:            mov     dx,03C8h
                mov     al,cl
                out     dx,al
                inc     dx
                mov     al,0
                out     dx,al
                out     dx,al
                out     dx,al
                inc     cl
                jnz     pal

                ret

pal_0           ENDP




pal_off         PROC NEAR

                mov     cx,64
ciclo_off:      mov     si,OFFSET fine_codice
                xor     bl,bl
pal_r2:         mov     dx,03C7h
                mov     al,bl
                out     dx,al
                inc     dx
                inc     dx
                in      al,dx
                or      al,al
                jz      no12
                dec     al
no12:           mov     [si],al
                in      al,dx
                or      al,al
                jz      no22
                dec     al
no22:           mov     [si+1],al
                in      al,dx
                or      al,al
                jz      no32
                dec     al
no32:           mov     [si+2],al
                add     si,3
                inc     bl
                jnz     pal_r2

                mov     dx,03DAh
wait12:         in      al,dx
                test    al,08
                jnz     wait12
wait22:         in      al,dx
                test    al,08
                jz      wait22

                mov     si,OFFSET fine_codice
                xor     bl,bl
                mov     dx,03C8h
pal_w2:         mov     al,bl
                out     dx,al
                inc     dx
                mov     al,[si]
                out     dx,al
                mov     al,[si+1]
                out     dx,al
                mov     al,[si+2]
                out     dx,al
                add     si,3
                dec     dx
                inc     bl
                jnz     pal_w2

                loop    ciclo_off

                ret

pal_off         ENDP






pal_on          PROC    NEAR

                mov     cx,64
ciclo_on:       mov     si,buffer2
                mov     di,buffer
                xor     bl,bl
pal_r:          mov     dx,03C7h
                mov     al,bl
                out     dx,al
                inc     dx
                inc     dx
                in      al,dx
                cmp     al,[di]
                je      no1
                inc     al
no1:            mov     [si],al
                in      al,dx
                cmp     al,[di+1]
                je      no2
                inc     al
no2:            mov     [si+1],al
                in      al,dx
                cmp     al,[di+2]
                je      no3
                inc     al
no3:            mov     [si+2],al
                add     si,3
                add     di,3
                inc     bl
                jnz     pal_r

                mov     dx,03DAh
wait1:          in      al,dx
                test    al,08
                jnz     wait1
wait2:          in      al,dx
                test    al,08
                jz      wait2

                mov     si,buffer2
                xor     bl,bl
                mov     dx,03C8h
pal_w:          mov     al,bl
                out     dx,al
                inc     dx
                mov     al,[si]
                out     dx,al
                mov     al,[si+1]
                out     dx,al
                mov     al,[si+2]
                out     dx,al
                add     si,3
                dec     dx
                inc     bl
                jnz     pal_w

                loop    ciclo_on

                ret

pal_on          ENDP


fine_codice:

end             start
